'************************************************************************************* 
' 
' Peter Mather
' 
' 1.3 
' 2015-20-1 
' 
' Graphics library with drivers for SSD1289 display with XPT2046 touch controller
' 16 bit parallel outuput from Micromite 44-pin
'
' drawing primitives assume a graphics display where top left is point 0, 0
'
' set screen orientation: sub T32.setrot(x) ;T32_normal=normal, T32_inverse=invert, T32_rt_right=rotate right, T32_rt_left=rotate left
' draw circle: sub T32.dcirc(x0, y0, r, colour) ;x, y coordinates of centre, radius, colour
' draw filled circle: sub T32.fcirc(x0, y0, r, colour) ;x, y coordinates of centre, radius, colour
' draw triangle:  sub T32.dtri(x0, y0, x1, y1, 	x2, y2, colour) ;three coordinate pairs, colour
' draw filled triangle sub T32.ftri (x0, y0, x1, y1, x2, y2, colour) ;three coordinate pairs, colour
' print string: sub T32.pstring(xx0, yy0, text$, sz, orientation, forecolour, backcolour) ;x, y coordinates of top left of first character, text string, size, character orientation,  foreground colour,  background colour
' print 8x5 bitmap: sub T32.pbitmap(xx0, yy0, char, sz, orientation, forecolour, backcolour) ;x, y coordinates of top left of first character, bitmap, size, character orientation,  foreground colour,  background colour
' draw line: sub T32.dline(xx0, yy0, xx1, yy1, colour) ;x, y of start line, x, y of end line, colour
' draw rectangle: sub T32.drect(x, y, w, h, colour) ;x, y coordinate of top left, width, height, colour
' draw filled rectangle: sub T32.frect(x, y, w, h, colour) ;x, y coordinate of top left, width, height, colour
' draw rounded rectangle: sub T32.drndrect(x, y, w, h, r, colour) ;x, y coordinates of top left, width, height, radius of corner, colour
' draw filled rounded rectangle: sub T32.frndrect(x, y, w, h, r, colour) ;x, y coordinates of top left, width, height, radius of corner, colour
'
option explicit
option default NONE
cpu 48
  print "start Init"
  T32.initdisplay
  print "Start main"
Do
   T32_test
loop

end
'
' 
 specific routines
'
sub T32.initdisplay
'Fixed Pins
  setpin 25,dout 'c0 - connect to D0
  setpin 26,dout 'c1 - connect to D1
  setpin 27,dout 'c2 - connect to D2
  setpin 36,dout 'c3 - connect to D3
  setpin 37,dout 'c4 - connect to D4
  setpin 38,dout 'c5 - connect to D5
  setpin 2 ,dout 'c6 - connect to D6
  setpin 3 ,dout 'c7 - connect to D7
  setpin 4 ,dout 'c8 - connect to D8
  setpin 5 ,dout 'c9 - connect to D9
  setpin 30,dout 'a2 - connect to D10
  setpin 31,dout 'a3 - connect to D11
  setpin 13,dout 'a7 - connect to D12
  setpin 32,dout 'a8 - connect to D13
  setpin 35,dout 'a9 - connect to D14
  setpin 12,dout 'a10 - connect to D15
  dim integer T32_WR=21 'b0
  dim integer T32_CD=22 'b1
' Connect RD to VCC
' Connect CS to GND
' Connect SPI CLOCK to T_CLK
' Connect SPI OUT to T_DIN
' Connect SPI IN to T_DO
'
'Flexible pins
  dim integer T_IRQ=10 'T_IRQ
  dim integer T_CS=11  'T_CS
  DIM integer Master_reset=15 ' connect to reset pin display
'
  dim integer BLACK = &H0000 ' Color definitions: 16 bit (RGB565) colour palette so these are just examples
  dim integer BLUE  = &H001F
  dim integer RED   = &HF800
  dim integer GREEN = &H07E0
  dim integer CYAN  = &H07FF
  dim integer MAGENTA=&HF81F
  dim integer YELLOW= &HFFE0 
  dim integer WHITE = &HFFFF
  dim integer T32.pix=0
  dim integer T32.ffr=1
  dim integer T32.filltri=2
  dim integer T32.drawline=3
  dim integer T32.writecommand=4
  dim integer T32.writedata=5
  dim integer T32.fpstring=7
  dim integer T32.fcirch=8
  dim integer T32.dcirch=9
  dim integer T32_normal=0
  dim integer T32_inverse=1
  dim integer T32_rt_right=2
  dim integer T32_rt_left=3
  ' Global variables
  dim integer T32_AddrOfFont,   T32_params(6) ' Global variables
  DIM integer T32_wi=0,T32_ht=1,T32_rot=2,T32_nr=3,T32_X=4,T32_Y=5,T32_seed=6
  T32_AddrOfFont=PEEK(CFunAddr FONT)  
  local integer i,j,k
  T32_params(T32_wi)=240
  T32_params(T32_ht)=320
  pin(T32_CD)=1
  setpin T32_CD, DOUT
  pin(T32_WR)=1
  setpin T32_WR, DOUT
  pin(Master_RESET)=1
  setpin Master_RESET, DOUT'  Resets the display and the 74HC595s
  pin(Master_RESET)=0
  pause 100
  pin(Master_RESET)=1
  pause 100
  spi open 1000000,3,8
  setpin T_IRQ,din,pullup
  pin(T_CS)=1
  setpin T_CS,dOUT
  i=T.Getdata(&HA0) 'wake up the controller
 	T32.wreg(&H00,&H0001)
	T32.wreg(&H03,&HA8A4)
	T32.wreg(&H0C,&H0000)
	T32.wreg(&H0D,&H080C)
	T32.wreg(&H0E,&H2B00)
	T32.wreg(&H1E,&H00B7)
	T32.wreg(&H01,&H2B3F)
	T32.wreg(&H02,&H0600)
	T32.wreg(&H10,&H0000)
	T32.wreg(&H11,&H6070)
	T32.wreg(&H05,&H0000)
	T32.wreg(&H06,&H0000)
	T32.wreg(&H16,&HEF1C)
	T32.wreg(&H17,&H0003)
	T32.wreg(&H07,&H0233)
	T32.wreg(&H0B,&H0000)
	T32.wreg(&H0F,&H0000)
	T32.wreg(&H41,&H0000)
	T32.wreg(&H42,&H0000)
	T32.wreg(&H48,&H0000)
	T32.wreg(&H49,&H013F)
	T32.wreg(&H4A,&H0000)
	T32.wreg(&H4B,&H0000)
	T32.wreg(&H30,&H0707)
	T32.wreg(&H31,&H0204)
	T32.wreg(&H32,&H0204)
	T32.wreg(&H33,&H0502)
	T32.wreg(&H34,&H0507)
	T32.wreg(&H35,&H0204)
	T32.wreg(&H36,&H0204)
	T32.wreg(&H37,&H0502)
	T32.wreg(&H3A,&H0302)
	T32.wreg(&H3B,&H0302)
	T32.wreg(&H23,&H0000)
	T32.wreg(&H24,&H0000)
	T32.wreg(&H25,&H8000)
  pause 50
  T32.setrot(T32_normal)
end sub
'
sub T32.wreg(register as integer, databyte as integer)
  local integer i
  i=T32draw(T32.writecommand, register)
  i=T32draw(T32.writedata, databyte)
end sub
'
sub T32.fillscreen(scol as integer)
  local integer i=T32_params(T32_rot)
  T32_params(T32_rot)=0
  local integer j=T32draw(T32.ffr,scol, 0,0,T32_params(T32_wi),T32_params(T32_ht), T32_params())
  T32_params(T32_rot)=i
end sub
'
function T.Getdata(command as integer) as integer 'get data from the touch controller
  local integer i,j,k
  pin(T_CS)=0
  i=spi(command)
  j=spi(0)
  k=spi(0)
  pin(T_CS)=1
  T.Getdata= (j*256+k)>>4
end function
'
function T.getxy(x as integer, y as integer, timeout as integer) as integer
  timer=0
  do while timer<timeout and pin(T_IRQ)=1:loop
  if timer>=timeout then 
    T.getxy=0
  else
    y=T.getdata(&H90)
    x=T.getdata(&HD0)
    T.getxy=1
  endif
end function
'
'
' Generic drawing routines
'
sub T32.dcirc(x0 as integer, y0 as integer, r as integer, colour as integer) 'x, y coordinates of centre, radius
  local integer i=T32draw(T32.dcirch, colour,x0,y0,r,31,T32_params())

end sub
 '
sub T32.dtri(x0 as integer, y0 as integer, x1 as integer, y1 as integer, x2 as integer, y2 as integer, colour as integer) 'three coordinate pairs
  T32.dline(x0, y0, x1, y1, colour)
  T32.dline(x1, y1, x2, y2, colour)
  T32.dline(x2, y2, x0, y0, colour)
end sub
 '
sub T32.ftri(x0 as integer, y0 as integer, x1 as integer, y1 as integer, x2 as integer, y2 as integer, colour as integer) 'three coordinate pairs
  local integer i=T32draw(T32.filltri, x0,y0,x1,y1,x2,y2,colour,T32_params())
end sub
'
sub T32.pstring(xx0 as integer, yy0 as integer, text$, sz as integer, orientation as integer, fontcolour as integer, backgroundcolour as integer) 'x, y coordinates of top left of first character, text string, size, orientation
  local integer i=T32draw(T32.fpstring,T32_AddrOfFont,xx0,yy0,sz,orientation,fontcolour,backgroundcolour,T32_params(),text$)
end sub
'
sub T32.pbitmap(xx0 as integer, yy0 as integer, char as integer, sz as integer, orientation as integer, fontcolour as integer, backgroundcolour as integer) 'x, y coordinates of top left of first character, text string, size, orientation
  local integer i=T32draw(T32.fpstring,char,xx0,yy0,sz,orientation,fontcolour,backgroundcolour,T32_params(),"")
end sub
'
sub T32.dline(xx0 as integer, yy0 as integer, xx1 as integer, yy1 as integer, colour as integer) ' x, y of start line, x, y of end line
   local integer dp=T32draw(T32.drawline, colour, xx0, yy0, xx1, yy1,  T32_params())
end sub
 '
sub swap (a% , b% )
  local  t%
  t%=b%
  b%=a%
  a%=t%
end sub
 '
sub T32.drect(x as integer, y as integer, w as integer, h as integer, rcolour as integer) 'x, y coordinate of top left, wi, ht
  local integer a, dp
  dp=T32draw(T32.ffr, rcolour, x, y, w, 1,  T32_params()) 
  a=y+h-1
  dp=T32draw(T32.ffr, rcolour, x, a, w, 1,  T32_params()) 
  dp=T32draw(T32.ffr, rcolour, x, y, 1, h,  T32_params()) 
  a=x+w-1
  dp=T32draw(T32.ffr, rcolour, a, y, 1, h,  T32_params()) 
end sub
'
sub T32.frect(x as integer, y as integer, w as integer, h as integer, rcolour as integer) 'x, y coordinate of top left, width, height
  local integer dp
  dp=T32draw(T32.ffr, rcolour, x, y, w, h,  T32_params()) 
end sub
'
FUNCTION T32.Getchar(char as integer) as integer
  local integer i=char<<3
  T32.Getchar=PEEK(WORD T32_AddrOfFont+i)+(PEEK(WORD T32_AddrOfFont+i+4)<<32) 
END FUNCTION
'
sub T32.fcirc(x0 as integer, y0 as integer, r as integer, ccolour as integer)  'x, y coordinates of centre, radius
  local integer dp
  dp=T32draw(T32.ffr, ccolour, x0, y0-r, 1, 2*r+1,  T32_params())
  dp=T32draw(T32.fcircH,x0, y0, r, 3, 0, ccolour, T32_params())
end sub
 '
sub T32.drndrect(x as integer, y as integer, w as integer, h as integer, r as integer, rcolour as integer) 'x, y coordinates of top left, width, height, radius of corner
  local integer dp
  dp=T32draw(T32.ffr, rcolour, x+r, y, w-2*r, 1,  T32_params()) 
  dp=T32draw(T32.ffr, rcolour, x+r, y+h-1, w-2*r, 1,  T32_params()) 
  dp=T32draw(T32.ffr, rcolour, x, y+r, 1, h-2*r,  T32_params()) 
  dp=T32draw(T32.ffr, rcolour, x+w-1, y+r, 1, h-2*r,  T32_params()) 
  dp=T32draw(T32.dcirch, rcolour, x+r, y+r, r, 1,T32_params())
  dp=T32draw(T32.dcirch,  rcolour, x+w-r-1, y+r, r, 2,T32_params())
  dp=T32draw(T32.dcirch,  rcolour, x+w-r-1, y+h-r-1, r, 4,T32_params())
  dp=T32draw(T32.dcirch,  rcolour, x+r, y+h-r-1, r, 8,T32_params())
end sub
'
sub T32.frndrect(x as integer, y as integer, w as integer, h as integer, r as integer, colour as integer) 'x, y coordinates of top left, width, height, radius of corner
  local integer dp
  dp=T32draw(T32.ffr, colour, x+r, y, w-2*r, h,  T32_params()) 
  dp=T32draw(T32.fcircH,x+w-r-1, y+r, r, 1, h-2*r-1, colour, T32_params())
  dp=T32draw(T32.fcircH,x+r, y+r, r, 2, h-2*r-1, colour, T32_params())
end sub
 '
sub T32.setrot(x%) 'sets screen rotation: 0=T32_normal, 1=invert, 2=rotate right, 3-rotate left
   T32_params(T32_rot)=(x% and 3)
end sub
'
'D:\Peter\MPLABXProjects\TFT32par\dist\default\production\T32draw.bas

'
'T32draw  2015-01-20 17:05:08 CFuncGen Ver 1.0.21 by user=Peter
'
CFunction T32draw
'writeCommand
	000006F8
	3c02bf88 24030002 ac436134 ac446230 8c436030 3063f873 ac436030 24030001 
	ac436134 ac436138 03e00008 00000000 

'writeData10
3c02bf88 24030002 ac436138 ac446230 
	8c436030 3063f873 ac436030 24030001 ac436134 ac436138 03e00008 00000000 

'writeData
	3c02bf88 24030002 ac436138 ac446230 8c436030 3063f873 ac436030 3084fc00 
	8c456030 00041a02 3063000c 00651825 ac436030 8c436030 00042142 30840780 
	00832025 ac446030 24030001 ac436134 ac436138 03e00008 00000000 

'setxy
3c02bf88 
	8c436030 3063f873 ac436030 24060002 ac466134 2403004e ac436230 24030001 
	ac436134 ac436138 ac466138 ac446230 ac436134 ac436138 ac466134 2404004f 
	ac446230 ac436134 ac436138 ac466138 ac456230 ac436134 ac436138 ac466134 
	24040022 ac446230 ac436134 ac436138 03e00008 00000000 

'localfastfillrect
27bdffc8 afbf0034 
	afb70030 afb6002c afb50028 afb40024 afb30020 afb2001c afb10018 afb00014 
	00808021 8faa0048 8fa9004c 8fac0050 8fad0054 8fae0058 8faf005c 8fa20060 
	8c4b0000 8c480010 1500002d 8c580008 04e00005 00002821 14a700fa 00cb102b 
	10400101 00002021 24c2ffff 0046202b 24e3ffff 00832021 004c1821 0062102b 
	008d2021 00441021 04400006 00609021 54a20004 2572ffff 006b182b 50600001 
	2572ffff 05200005 00002021 148900e8 0158102b 104000ec 00002821 2542ffff 
	004a282b 2523ffff 00a32821 004e1821 0062102b 00af2821 00451021 044000ef 
	00609821 548200ed 2712ffff 0078182b 546000eb 0140a021 100000e8 2712ffff 
	24020001 5502002c 24020002 00063027 00073827 00cb5821 0166302b 00c73021 
	01609021 00002021 04c000cf 00002821 000a5027 00094827 0158c021 030a502b 
	01494821 052000c8 03009821 24020001 004c6023 004c102b 00c23023 018b5821 
	016c602b 00cd6823 018dc821 00191fc3 00032827 000517c3 01622024 00808821 
	24020001 004e7023 004e102b 01224823 01d8c021 030e702b 012f7823 01cf1821 
	00031fc3 00032827 000517c3 03022024 10000067 0080a021 15020036 000a2027 
	00092827 008b1021 0044182b 00651821 00409021 04600008 00602021 54600005 
	2572ffff 004b102b 14400004 24020001 2572ffff 00002021 24020001 004e2823 
	0045102b 00822023 00b21821 0065282b 008f2023 00608821 00a4c821 00192fc3 
	00051827 000327c3 02241024 00408821 04e00005 00002021 14870087 00d8102b 
	10400089 00002821 24c2ffff 0046282b 24e3ffff 00a32821 004c1821 0062102b 
	00ad2821 00451021 04400009 00609821 54820005 2713ffff 0078182b 54600005 
	00c0a021 2713ffff 10000002 00c0a021 00c0a021 24020003 1502002e 26570001 
	05200005 00001821 1469006d 014b102b 1040006c 00002021 2542ffff 004a282b 
	2524ffff 00a42021 004e7021 01c2102b 008f7821 004f1021 04400007 01c09021 
	54620005 2572ffff 01cb702b 55c00003 00063027 2572ffff 00063027 00073827 
	00d8c021 0306302b 00c73021 03009821 00002021 04c00054 00002821 24020001 
	004c6023 004c102b 00c23023 0198c021 030c602b 00cd6823 018d1821 0300a021 
	04610003 01408821 01408821 0000a021 26570001 02f1b823 26620001 00541023 
	72e2b802 24040044 0411FED5 00000000 00122200 00912021 0411FEE9 00000000 
	24040045 0411FECE 00000000 02802021 0411FED7 00000000 24040046 0411FEC8 
	00000000 02602021 0411FED1 00000000 02202021 02802821 0411FEF0 00000000 
	3c02bf88 ac506230 8c436030 3063f873 ac436030 3210fc00 8c446030 00101a03 
	3063000c 00641825 ac436030 8c436030 00108143 32100780 02038025 ac506030 
	24030002 ac436138 24040001 12e00016 00002821 26f7ffff 3c03bf88 24020001 
	2404ffff ac626134 ac626138 26f7ffff 16e4fffc 00000000 24040001 1000000a 
	00002821 00002021 10000007 00002821 10000005 00002821 10000003 00002821 
	00002021 00002821 00801021 00a01821 8fbf0034 8fb70030 8fb6002c 8fb50028 
	8fb40024 8fb30020 8fb2001c 8fb10018 8fb00014 03e00008 27bd0038 0140a021 
	1000ff7c 00c08821 

'localdrawPixel
27bdffe0 afbf001c afb10018 afb00014 00808021 8fa20030 
	8c480000 8c430008 8c420010 24040001 14440006 00a08821 00063027 00c82021 
	00072827 1000000f 00a32821 24040002 54440005 24040003 00072027 00882021 
	10000008 00c02821 14440004 00062827 00a32821 10000003 00e02021 00e02821 
	00c02021 00851027 000217c2 0088402a 00a3182a 01031824 00431824 00004021 
	1060000f 00004821 0411FE8C 00000000 3c02bf88 24030002 ac436138 ac506230 
	8c436030 02238825 ac516030 24030001 ac436134 ac436138 24080001 00004821 
	01001021 01201821 8fbf001c 8fb10018 8fb00014 03e00008 27bd0020 

'drawPixel
27bdffe0 
	afbf001c 00a01821 00c01021 3086fc00 00064203 3108000c 00063143 30c50780 
	afa70010 00a82825 00603021 00403821 0411FFB5 00000000 8fbf001c 03e00008 
	27bd0020 

'swap
8c820000 8ca30000 ac830000 03e00008 aca20000 

'drawline
27bdffb0 afbf004c 
	afb70048 afb60044 afb50040 afb4003c afb30038 afb20034 afb10030 afb0002c 
	8fa50060 8fa20068 8fa30070 8fb50078 afa60018 afa5001c afa20020 afa30024 
	0080a021 3084fc00 00043a02 30e7000c 00042142 30930780 00a3882a 00652023 
	00a31823 0071200a 00808821 00c2202a 00461823 00c21023 0064100b 0051882a 
	12200009 02679825 27a40018 27a5001c 0411FFD4 00000000 27a40020 27a50024 
	0411FFD0 00000000 8fa20020 8fa30018 0043102a 1040000a 8fa20020 27a40018 
	27a50020 0411FFC7 00000000 27a4001c 27a50024 0411FFC3 00000000 8fa20020 
	8fa70018 8fa30024 8fb2001c 0243202a 10800007 0047b023 00729023 001687c2 
	02168021 00108043 10000006 24170001 02439023 001687c2 02168021 00108043 
	2417ffff 0047102a 1440001e 8fbf004c 12200008 afb50010 02802021 02602821 
	8fa6001c 0411FF58 00000000 10000008 02128023 02802021 02602821 00e03021 
	8fa7001c 0411FF50 00000000 02128023 06010006 8fa70018 8fa2001c 00571021 
	afa2001c 02168021 8fa70018 24e70001 afa70018 8fa20020 0047102a 1040ffe4 
	8fbf004c 8fb70048 8fb60044 8fb50040 8fb4003c 8fb30038 8fb20034 8fb10030 
	8fb0002c 03e00008 27bd0050 

'drawchar
27bdff68 afbf0094 afbe0090 afb7008c afb60088 
	afb50084 afb40080 afb3007c afb20078 afb10074 afb00070 8fa200a8 8fa300b0 
	afa30048 8fa300b8 afa30050 8fa300c0 afa30064 8fb400d0 8fa30050 afa30058 
	8fb00064 8fa300c8 afa3004c 00c0f021 30c6fc00 00061a03 3063000c 00063143 
	30c60780 00c33025 afa6005c 0040b821 3042fc00 00021a03 3063000c 00021143 
	30420780 00431025 afa20060 afa40030 afa50034 8fa5004c 14a0005c 24020001 
	00101023 afa20054 00101080 00501021 8fa50048 00a21021 afa20044 24a20005 
	afa2003c 27b60030 27a30036 afa30038 00009021 02008821 afbe0040 02e0f021 
	10000045 0280a821 92c20000 02021007 30420001 1040001a 24020001 24050001 
	5625000a afb30010 afb50010 8fa40040 8fa5005c 8fa6003c 02803821 0411FEEA 
	00000000 10000025 26100001 afb20014 afb10018 afb2001c afb10020 afb20024 
	afb50028 8fa40040 02e03021 02403821 0411FDB1 00000000 10000018 26100001 
	5622000a afb30010 afb50010 03c02021 8fa50060 8fa6003c 02803821 0411FED2 
	00000000 1000000d 26100001 afb20014 afb10018 afb2001c afb10020 afb20024 
	afb50028 03c02021 02e03021 02403821 0411FD99 00000000 26100001 02719821 
	24030008 1603ffc8 26940001 8fa50044 8fa20054 00a22821 afa50044 8fa3003c 
	2463ffff afa3003c 26d60001 8fa50038 52c5006c 02208021 8fb70044 8fb40050 
	8fb30058 1000ffb8 02408021 8fa3004c 14620068 24020002 8fa50064 00052823 
	afa50054 8fa30048 24620001 8fa50064 00451023 afa20044 afa3003c 27b60035 
	27a2002f afa20038 00009021 8fa50058 00b01823 24630001 001010c0 00501023 
	00621023 afa20068 02008821 afbe0040 02e0f021 10000045 0280a821 92c20000 
	02021007 30420001 1040001a 24030001 24020001 5622000a afb30010 afb50010 
	8fa40040 8fa5005c 8fa6003c 02803821 0411FE85 00000000 10000025 2610ffff 
	afb20014 afb10018 afb2001c afb10020 afb20024 afb50028 8fa40040 02e03021 
	02403821 0411FD4C 00000000 10000018 2610ffff 5623000a afb30010 afb50010 
	03c02021 8fa50060 8fa6003c 02803821 0411FE6D 00000000 1000000d 2610ffff 
	afb20014 afb10018 afb2001c afb10020 afb20024 afb50028 03c02021 02e03021 
	02403821 0411FD34 00000000 2610ffff 02719821 2405ffff 1605ffc8 26940001 
	8fa20044 8fa30054 00431021 afa20044 8fa5003c 24a5ffff afa5003c 26d6ffff 
	8fa20038 52c2006c 02208021 8fb70044 8fb30068 8fa30058 2474fff9 1000ffb7 
	24100007 03c0b821 8fbe0040 02a0a021 24020002 8fa5004c 14a20063 24020003 
	8fa20064 00021023 afa20054 8fa30048 24620001 8fa50064 00451023 afa20040 
	afa0003c 24160001 00009021 27a2002f afa20038 02008821 afbe0044 afb7004c 
	10000046 0280b821 92020000 02a21024 10400019 00000000 5636000a afb30010 
	afb70010 8fa40044 8fa5005c 8fa60048 02803821 0411FE24 00000000 10000025 
	2610ffff afb20014 afb10018 afb2001c afb10020 afb20024 afb70028 8fa40044 
	03c03021 02403821 0411FCEB 00000000 10000018 2610ffff 5636000a afb30010 
	afb70010 8fa4004c 8fa50060 8fa60048 02803821 0411FE0C 00000000 1000000d 
	2610ffff afb20014 afb10018 afb2001c afb10020 afb20024 afb70028 8fa4004c 
	03c03021 02403821 0411FCD3 00000000 2610ffff 02719821 8fa30038 1603ffca 
	26940001 8fa5003c 24a50001 afa5003c 8fa20040 8fa30054 00431021 afa20040 
	8fa50048 24a5ffff afa50048 8fa2003c 24030008 1043007b 8fbf0094 8fa5003c 
	00b6a804 8fbe0040 27b00035 8fb40050 1000ffb5 8fb30058 03c0b821 8fbe0040 
	02a0a021 24020003 8fa3004c 1462006c 8fa50050 24a40001 8fa20064 00021840 
	000210c0 00431823 00831823 afa3004c 8fa30064 00031823 afa30054 8fa50064 
	00451023 8fa30048 00621021 afa20044 24650007 afa50040 24020007 afa2003c 
	00009021 27a30036 afa30038 afbe0048 afb70050 10000048 0280b821 92220000 
	02c21024 1040001a 24020001 24050001 5605000a afb40010 afb70010 8fa40048 
	8fa5005c 8fa60040 02a03821 0411FDB6 00000000 10000025 26310001 afb20014 
	afb00018 afb2001c afb00020 afb20024 afb70028 8fa40048 03c03021 02403821 
	0411FC7D 00000000 10000018 26310001 5602000a afb30010 afb70010 8fa40050 
	8fa50060 8fa60040 02a03821 0411FD9E 00000000 1000000d 26310001 afb20014 
	afb00018 afb2001c afb00020 afb20024 afb70028 8fa40050 03c03021 02403821 
	0411FC65 00000000 26310001 0290a021 26b50001 8fa30038 1623ffc8 02709821 
	8fa5003c 24a5ffff afa5003c 8fa20044 8fa30054 00431021 afa20044 8fa50040 
	24a5ffff afa50040 8fa2003c 2403ffff 1043000c 8fbf0094 24050001 8fa2003c 
	0045b004 8fbe0044 27b10030 8fa30058 2475fffb 8fb3004c 1000ffb0 0260a021 
	8fbf0094 8fbe0090 8fb7008c 8fb60088 8fb50084 8fb40080 8fb3007c 8fb20078 
	8fb10074 8fb00070 03e00008 27bd0098 

'nextchar
14e00008 24020001 00061040 000618c0 
	00621023 8c830000 00621021 10000012 ac820000 14e20007 00061040 000630c0 
	00463023 8c820000 00463021 03e00008 ac860000 24020002 14e20007 00061040 
	000630c0 00c23023 8ca20000 00463021 03e00008 aca60000 24020003 14e20006 
	00061040 000630c0 00463023 8ca20000 00463021 aca60000 03e00008 00000000 

'pstring
	27bdff78 afbf0084 afbe0080 afb7007c afb60078 afb50074 afb40070 afb3006c 
	afb20068 afb10064 afb00060 8fa30098 8fb000a0 8fa200a8 afa20048 8fa700b0 
	8fa800b8 8fb500c0 8fb400c4 afa60040 afa30044 02009021 00409821 00e0b021 
	afa40058 92820000 1040003f 0100b821 1840005a 24100001 00071fc3 afa30048 
	000817c3 afa2004c 00121fc3 afa30050 001317c3 afa20054 02901021 90420000 
	2443ffe0 306300ff 2c630060 50600008 00002021 2442ffe0 000210c0 8fa30058 
	00431021 8c440000 10000002 8c450004 00002821 afb70010 8fa2004c afa20014 
	8fa20040 afa20018 000217c3 afa2001c 8fa20044 afa20020 000217c3 afa20024 
	afb20028 8fa30050 afa3002c afb30030 8fa20054 afa20034 afb50038 02c03021 
	8fa70048 0411FDC1 00000000 00408821 0060f021 27a40040 27a50044 02403021 
	02603821 0411FF8A 00000000 26100001 92820000 0050102a 5040ffd0 02901021 
	1000001f 8fa20040 afa80010 000847c3 afa80014 afa60018 000637c3 afa6001c 
	afa30020 00031fc3 afa30024 afb00028 001017c3 afa2002c 8fa30048 afa30030 
	000317c3 afa20034 afb50038 00e03021 00073fc3 0411FD9D 00000000 00408821 
	0060f021 27a40040 27a50044 02003021 8fa70048 0411FF66 00000000 8fa20040 
	aea20020 000217c3 aea20024 8fa20044 aea20028 000217c3 aea2002c 02201021 
	03c01821 8fbf0084 8fbe0080 8fb7007c 8fb60078 8fb50074 8fb40070 8fb3006c 
	8fb20068 8fb10064 8fb00060 03e00008 27bd0088 

'dcirch
27bdffa0 afbf005c afbe0058 
	afb70054 afb60050 afb5004c afb40048 afb30044 afb20040 afb1003c afb00038 
	00808021 00c0b021 8fb50070 8fb20078 8fa20080 8fbe0088 02408821 afa60024 
	afb50028 afa20020 afa40018 3083fc00 00032202 3084000c 0003b942 32f70780 
	30420010 1040001c 02e4b825 afbe0010 02002021 02e02821 02553821 0411FC92 
	00000000 afbe0010 02002021 02e02821 02c03021 02b23823 0411FC8B 00000000 
	afbe0010 02002021 02e02821 02563021 02a03821 0411FC84 00000000 afbe0010 
	02002021 02e02821 02d23023 02a03821 0411FC7D 00000000 1a200073 24110001 
	02328823 00121023 00021040 afa2001c 26b3ffff 26d4ffff 26b50001 26d60001 
	02408021 00009021 8fa20020 30420004 afa2002c 8fa20020 30420002 afa20030 
	8fa20020 30420008 afa20034 8fa20020 30420001 afa20020 06200005 8fa2001c 
	2610ffff 24420002 afa2001c 02228821 8fa2002c 10400011 26520001 afbe0010 
	8fa40018 02e02821 02c03021 8fa20028 02023821 0411FC54 00000000 afbe0010 
	8fa40018 02e02821 8fa20024 02023021 02a03821 0411FC4C 00000000 8fa20030 
	10400012 8fa20034 afbe0010 8fa40018 02e02821 02c03021 8fa20028 00503823 
	0411FC41 00000000 afbe0010 8fa40018 02e02821 8fa20024 02023021 02603821 
	0411FC39 00000000 8fa20034 10400012 8fa20020 afbe0010 8fa40018 02e02821 
	8fa20024 00503023 02a03821 0411FC2E 00000000 afbe0010 8fa40018 02e02821 
	02803021 8fa20028 02023821 0411FC26 00000000 8fa20020 50400012 2673ffff 
	afbe0010 8fa40018 02e02821 8fa20024 00503023 02603821 0411FC1B 00000000 
	afbe0010 8fa40018 02e02821 02803021 8fa20028 00503823 0411FC13 00000000 
	2673ffff 2694ffff 26b50001 0250102a 10400005 26d60001 00121040 24420001 
	1000ffa5 02228821 8fbf005c 8fbe0058 8fb70054 8fb60050 8fb5004c 8fb40048 
	8fb30044 8fb20040 8fb1003c 8fb00038 03e00008 27bd0060 

'fcirch
27bdff90 afbf006c 
	afbe0068 afb70064 afb60060 afb5005c afb40058 afb30054 afb20050 afb1004c 
	afb00048 8fb10080 8fb40090 8fbe0098 afa40038 afa6003c 8fa20088 1a200076 
	02801821 24100001 02118023 0011b823 0017b840 2495ffff 24d3ffff 26940003 
	24960001 00009021 30440001 afa40030 24630001 afa30040 30420002 afa20034 
	06000004 8fa20030 2631ffff 26f70002 02178021 1040002a 26520001 8fa3003c 
	00711023 afa20010 000217c3 afa20014 24020001 00001821 afa20018 afa3001c 
	00111040 8fa30040 00621021 afa20020 000217c3 afa20024 8fa400a0 afa40028 
	03c02021 02c03021 00163fc3 0411FA92 00000000 8fa20038 02223821 afb30010 
	001317c3 afa20014 24020001 00001821 afa20018 afa3001c afb40020 001417c3 
	afa20024 8fa300a0 afa30028 03c02021 00e03021 00073fc3 0411FA7F 00000000 
	8fa40034 5080002b 26b5ffff 8fa3003c 00711023 afa20010 000217c3 afa20014 
	24020001 00001821 afa20018 afa3001c 00111040 8fa30040 00621021 afa20020 
	000217c3 afa20024 8fa400a0 afa40028 03c02021 02a03021 00153fc3 0411FA66 
	00000000 8fa20038 00513823 afb30010 001317c3 afa20014 24020001 00001821 
	afa20018 afa3001c afb40020 001417c3 afa20024 8fa300a0 afa30028 03c02021 
	00e03021 00073fc3 0411FA53 00000000 26b5ffff 2673ffff 26940002 0251102a 
	10400005 26d60001 00121040 24420001 1000ff9b 02028021 8fbf006c 8fbe0068 
	8fb70064 8fb60060 8fb5005c 8fb40058 8fb30054 8fb20050 8fb1004c 8fb00048 
	03e00008 27bd0070 

'ftri
27bdff90 afbf006c afb50068 afb40064 afb30060 afb2005c 
	afb10058 afb00054 8fa20088 8fb100a0 8fb200a8 afa40038 afa6003c 8fa30080 
	afa30040 afa20044 8fa30090 afa30048 8fa30098 0046102a 10400009 afa3004c 
	27a4003c 27a50044 0411FB9E 00000000 27a40038 27a50040 0411FB9A 00000000 
	8fa2004c 8fa30044 0043102a 1040000a 8fa20044 27a4004c 27a50044 0411FB91 
	00000000 27a40048 27a50040 0411FB8D 00000000 8fa20044 8fa3003c 0043102a 
	1040000a 8fb0003c 27a4003c 27a50044 0411FB84 00000000 27a40038 27a50040 
	0411FB80 00000000 8fb0003c 8fa2004c 1602002d 8fb30044 8fa20038 afa20030 
	afa20034 8fa30040 0062202a 10800003 0043102a 10000003 afa30030 54400001 
	afa30034 8fa20048 8fa30030 0043182a 10600003 8fa30034 10000004 afa20030 
	0062182a 54600001 afa20034 8fa70030 8fa2003c afa20010 000217c3 afa20014 
	24020001 00001821 afa20018 afa3001c 8fa20034 24420001 00471023 afa20020 
	000217c3 afa20024 afb20028 02202021 00e03021 00073fc3 0411F9D7 00000000 
	10000077 8fbf006c 

'.LBB2
00531026 0002102b 02629823 0270102a 14400036 24140001 
	0000a821 8fa20038 8fa3003c 02032823 8fa60040 00c23023 70a63002 8fa40044 
	00832023 00c4001a 008001f4 00002012 00822021 afa40030 8fa60048 00c23023 
	70a62802 8fa6004c 00c31823 00a3001a 006001f4 00001812 00621021 afa20034 
	0044102a 10400006 8fa70030 27a40030 27a50034 0411FB2B 00000000 8fa70030 
	afb00010 001017c3 afa20014 8fa20034 24420001 00471023 afa20018 000217c3 
	afa2001c afb40020 afb50024 afb20028 02202021 00e03021 00073fc3 0411F99E 
	00000000 26100001 0270102a 1040ffce 8fa20038 8fa2004c 0050182a 14600037 
	24140001 0000a821 8fa60040 8fa40038 8fa50048 8fa80044 02083823 00a61823 
	70e33802 00484023 00e8001a 010001f4 00001812 00661821 afa30030 8fa7003c 
	02073023 00a42823 70c53002 00471023 00c2001a 004001f4 00001012 00442021 
	afa40034 0083202a 10800006 8fa70030 27a40030 27a50034 0411FAF2 00000000 
	8fa70030 afb00010 001017c3 afa20014 8fa20034 24420001 00471023 afa20018 
	000217c3 afa2001c afb40020 afb50024 afb20028 02202021 00e03021 00073fc3 
	0411F965 00000000 26100001 8fa2004c 0050182a 1060ffcd 8fa60040 

'.LBE2
8fbf006c 
	8fb50068 8fb40064 8fb30060 8fb2005c 8fb10058 8fb00054 03e00008 27bd0070 

'main
	27bdffb8 afbf0044 afb00040 00808021 00e01021 8fa90058 8faa005c 8fa80060 
	8fac0064 8c830000 8c840004 00643825 14e00009 8fab0068 8ca40000 8cc50000 
	8c460000 01203821 0411FAAC 00000000 100000c5 8fbf0044 24070001 14670017 
	24070002 14800015 00000000 8ca40000 8cc70004 8cc60000 8c430004 8c420000 
	afa20010 afa30014 8d220000 8d230004 afa20018 afa3001c 8d420000 8d430004 
	afa20020 afa30024 afa80028 0411F92A 00000000 100000ac 8fbf0044 14670021 
	24070003 1480001f 00000000 8ca40000 8ca50004 8cc70004 8cc60000 8c430004 
	8c420000 afa20010 afa30014 8d220000 8d230004 afa20018 afa3001c 8d420000 
	8d430004 afa20020 afa30024 8d020000 8d030004 afa20028 afa3002c 8d820000 
	8d830004 afa20030 afa30034 afab0038 0411FECD 00000000 8e020000 10000089 
	8e030004 14670019 24070004 14800017 00000000 8ca40000 8ca50004 8cc70004 
	8cc60000 8c420000 afa20010 000217c3 afa20014 8d220000 afa20018 000217c3 
	afa2001c 8d420000 afa20020 000217c3 afa20024 afa80028 0411FA6F 00000000 
	8e020000 1000006f 8e030004 14670009 24070005 14800007 00000000 8ca40000 
	0411F897 00000000 8e020000 10000065 8e030004 14670009 24070007 14800007 
	00000000 8ca40000 0411F8A5 00000000 8e020000 1000005b 8e030004 14670022 
	24070008 14800020 00000000 8ca40000 8ca50004 8cc70004 8cc60000 8c430004 
	8c420000 afa20010 afa30014 8d220000 8d230004 afa20018 afa3001c 8d420000 
	8d430004 afa20020 afa30024 8d020000 8d030004 afa20028 afa3002c 8d820000 
	8d830004 afa20030 afa30034 afab0038 8fa2006c afa2003c 0411FCA1 00000000 
	10000039 8fbf0044 1467001d 24070009 1480001b 00000000 8ca40000 8ca50004 
	8cc70004 8cc60000 8c430004 8c420000 afa20010 afa30014 8d220000 8d230004 
	afa20018 afa3001c 8d420000 8d430004 afa20020 afa30024 8d020000 8d030004 
	afa20028 afa3002c afac0030 0411FDCA 00000000 8e020000 1000001a 8e030004 
	14670019 8fbf0044 54800018 8fb00040 8ca40000 8ca50004 8cc70004 8cc60000 
	8c430004 8c420000 afa20010 afa30014 8d220000 8d230004 afa20018 afa3001c 
	8d420000 8d430004 afa20020 afa30024 afa80028 0411FCF7 00000000 8e020000 
	8e030004 8fbf0044 8fb00040 03e00008 27bd0048 
End CFunction

CFunction font
	00000000
	00000000 00000000 5f000000 00000000 00070000 00000007 147f1400 0000147f 
	7f2a1200 0000242a 08646200 00002313 56205000 00003649 07030000 00000008 
	22410000 0000001c 221c0000 00000041 7f1c2a00 00002a1c 3e080800 00000808 
	70300000 00000080 08080800 00000808 60600000 00000000 08040200 00002010 
	49453e00 00003e51 7f400000 00000042 49494600 00007249 494d3300 00002141 
	127f1000 00001814 45453900 00002745 49493100 00003c4a 11090700 00004121 
	49493600 00003649 49291e00 00004649 14000000 00000000 34000000 00000040 
	14224100 00000008 14141400 00001414 22140800 00000041 59090600 00000201 
	5d594e00 00003e41 11127c00 00007c12 49493600 00007f49 41412200 00003e41 
	41413e00 00007f41 49494100 00007f49 09090100 00007f09 41517300 00003e41 
	08087f00 00007f08 7f410000 00000041 413f0100 00002040 14224100 00007f08 
	40404000 00007f40 1c027f00 00007f02 08107f00 00007f04 41413e00 00003e41 
	09090600 00007f09 51215e00 00003e41 19294600 00007f09 49493200 00002649 
	7f010300 00000301 40403f00 00003f40 40201f00 00001f20 38403f00 00003f40 
	08146300 00006314 78040300 00000304 494d4300 00006159 41414100 0000007f 
	08102000 00000204 41417f00 00000041 01020400 00000402 40404000 00004040 
	07080000 00000003 54784000 00002054 44443800 00007f28 44442800 00003844 
	44287f00 00003844 54541800 00003854 7e090200 00000008 a49c7800 000018a4 
	04047800 00007f08 7d400000 00000044 403d0000 00002040 28440000 00007f10 
	7f400000 00000041 78047800 00007c04 04047800 00007c08 44443800 00003844 
	24241800 0000fc18 2418fc00 00001824 04040800 00007c08 54542400 00004854 
	3f442400 00000404 40207c00 00003c40 40201c00 00001c20 30403c00 00003c40 
	10284400 00004428 90907c00 00004c90 544c4400 00004464 36410000 00000008 
	77000000 00000000 36080000 00000041 02040200 00000201 23263c00 00003c26 
End CFunction
'
sub T32_test
  dim integer colours(7)=(red,blue,green,magenta,cyan,yellow,white,black)
  local integer x0, y0, x1, y1, wi, ht, colour=red
  local float tn
  local integer xvalues(3),yvalues(3)
' get these values for your display by using the calibrate program
  const xmin=125
  const xmax=1900
  const ymin=170
  const ymax=1950
  T32.setrot(0)
  wi= T32_params(0)
  ht= T32_params(1)
  T32.fillscreen(black)
  T32.drect(0, 0, wi, ht, red)
  T32.pstring(40, 40, "Welcome to the", 2, 0, green, black)
  T32.pstring(5, 70, "Micromite MK2", 3, 0, red, black)
  T32.pstring(60, 120, "in colour", 2, 0, yellow, black)
  T32.pstring(48, 170,  "SSD1289 controller", 1, 0, cyan, black)
  T32.pstring(54, 200,  "Touch Demo", 2, 0, green, black)
  pause 4000
  preparescreen
  do
    if T.getxy(xvalues(0),yvalues(0),1000) and T.getxy(xvalues(1),yvalues(1),1000) and T.getxy(xvalues(2),yvalues(2),1000) then 
      y0=filter(yvalues())
      x0=filter(xvalues())
      x1=(x0-xmin)*wi\(xmax-xmin)
      if y1<0 then y1=0
      y1=ht-((y0-ymin)*ht\(ymax-ymin))
      if x1<0 then x1=0
      if x1>=wi then x1=wi-1
'      print x0,y0,x1,y1
      if x1>=0 and y1>30 and x1<=wi-1 and y1<=ht-1 then
        T32.fcirc(x1,y1,3,colour)
      else
        if y1>ht-1 and x1<30 then
          preparescreen
        else
          if x1<wi-1 then colour=colours(x1\30)
        endif
      endif
    endif
  loop
end SUB
sub preparescreen
  T32.fillscreen(black)
  T32.FRECT(0,0,30,30,red)
  T32.FRECT(30,0,30,30,blue)
  T32.FRECT(60,0,30,30,green)
  T32.FRECT(90,0,30,30,magenta)
  T32.FRECT(120,0,30,30,cyan)
  T32.FRECT(150,0,30,30,yellow)
  T32.FRECT(180,0,30,30,white)
  T32.FRECT(210,0,30,30,black)
  T32.frect(0,30,240,1,white)
  T32.drect(0, 0, T32_params(T32_wi), T32_params(T32_ht), white)
end sub

function filter(values() as integer) as integer
  local integer AB,BC,AC
  AB=abs(values(0)-values(1))
  BC=ABS(values(1)-values(2))
  AC=ABS(values(0)-values(2))
  if AB<=BC and AB<=AC then filter=(values(0)+values(1))\2
  if BC<=AB and BC<=AC then filter=(values(1)+values(2))\2
  IF AC<=AB and AC<=BC then filter=(values(0)+values(2))\2
end function
